var game = new Phaser.Game(1200, 720, Phaser.AUTO, 'game')
var sections = new SECTION.Stack()

function start_new_game(){
	var game_state = new GameState()
	get_new_customer(game_state)
	sections.push(new EngineBaySection(game_state))
	sections.push(new PreDiscussWithCustomerSection(game_state))
}

function add_difficulty(game_state){
	//game_state.global_part_appearance_chance *= 0.8
	game_state.add_customer_partname()
	console.log("global_part_appearance_chance is now "+
			game_state.global_part_appearance_chance)
}

var PhaserState = function(){
}
PhaserState.prototype = {
	preload: function(){
		var imagenames = [
			"enginebay1",
			"valvecover",
			"customer_bubble",
			"customer_bubble_narrow",
			"continue_button",
			"mechanic_bubble_narrow",
			"empty",
			"empty_opaque",
			"procedure_background",
			"title_screen",
		]
		all_partnames.forEach(function(partname){
			imagenames.push("part_"+partname)
		})
		imagenames.forEach(function(imagename){
			game.load.image(imagename, "assets/"+imagename+".png")
		})
	},
	create: function(){
		game.scale.scaleMode = Phaser.ScaleManager.SHOW_ALL
		game.scale.pageAlignHorizontally = true
		game.stage.backgroundColor = 0x222222

		start_new_game()

		sections.push(new TitleSection())

		game.input.keyboard.addCallbacks(this, function(key){
			sections.on_key_down(key)
		}, function(key){
			sections.on_key_up(key)
		}, function(key){
			sections.on_key_press(key)
		})
	},
	update: function(){
	},
}

game.state.add("single_state", PhaserState)
game.state.start("single_state")

