var PostDiscussWithCustomerSection = function(game_state){
	this.grabs_input = true
	this.game_state = game_state
}
PostDiscussWithCustomerSection.prototype = {
	on_init: function(){
		this.base = game.add.group()

		this.background_mouse_catch = game.add.sprite(0,  0, "empty")
		this.base.add(this.background_mouse_catch)
		this.background_mouse_catch.inputEnabled = true
		this.background_mouse_catch.input.useHandCursor = true
		this.background_mouse_catch.events.onInputUp.add(function(){
			this.on_press_next()
		}, this)

		var established_procedure = this.game_state.known_procedures[this.game_state.customer.broken_partname]
		var current_procedure = this.game_state.current_procedure
		console.log("established_procedure=", established_procedure)
		console.log("current_procedure=", current_procedure)

		var lib = part_library[this.game_state.customer.broken_partname]
		if(this.game_state.current_work_cost == 0){
			this.sequence = [
				{
					party: "customer",
					header: "Customer:",
					text: "You didn't do any work! What kind of a weird scam is this?!",
				},
				{
					party: "mechanic",
					header: "Mechanic:",
					text: "Meh...",
					paid: this.game_state.current_work_cost + this.game_state.current_material_cost,
				},
			]
		} else if(established_procedure === undefined){
			this.sequence = [
				{
					party: "customer",
					header: "Customer:",
					text: "You fixed my "+lib.what+"! Great!",
					paid: this.game_state.current_work_cost + this.game_state.current_material_cost,
				},
			]
			// Remember this new procedure
			console.log("Remembering new procedure for "+this.game_state.customer.broken_partname+":", current_procedure)
			this.game_state.known_procedures[this.game_state.customer.broken_partname] = current_procedure
		} else {
			var match = match_procedure(established_procedure, current_procedure)
			if(match > 0.99) {
				this.sequence = [
					{
						party: "customer",
						header: "Customer:",
						text: "This is a perfect fix according to my friend!",
						paid: this.game_state.current_work_cost + this.game_state.current_material_cost,
					},
				]
				this.game_state.add_customer_partname()
				add_difficulty(this.game_state)
			} else if(match >= 0.5) {
				this.sequence = [
					{
						party: "customer",
						header: "Customer:",
						text: "According to my friend this fix is half-assed. You should follow your procedures! I'll pay "+(this.game_state.current_material_cost/4)+" €.",
						paid: this.game_state.current_material_cost/4
					},
				]
				add_difficulty(this.game_state)
			} else if(match >= 0.3) {
				/*this.sequence = [
					{
						party: "customer",
						header: "Customer:",
						text: "This is clearly a crappy fix; it's completely different than what you did to my friend's car! I'm not paying.",
						paid: 0,
					},
				]*/
				this.sequence = [
					{
						party: "customer",
						header: "Customer:",
						text: "This is clearly a crappy fix; it's completely different than what you did to my friend's car! I'm suing you "+(this.game_state.current_material_cost)+" € for damages!",
						paid: -this.game_state.current_material_cost,
					},
				]
			} else {
				this.sequence = [
					{
						party: "customer",
						header: "Customer:",
						text: "This is clearly a crappy fix; it's completely different than what you did to my friend's car! I'm suing you "+(this.game_state.current_material_cost * 3)+" € for damages!",
						paid: -this.game_state.current_material_cost * 3,
					},
				]
			}
		}
		this.sequence_i = 0

		this.update_bubble()

		add_statusbar(this.base, this.game_state)
	},
	on_remove: function(){
		this.base.destroy()
	},
	update_bubble: function(){
		var step = this.sequence[this.sequence_i]

		if(step.paid !== undefined){
			var profit = step.paid - this.game_state.current_material_cost
			console.log("materials "+this.game_state.current_material_cost+", paid "+step.paid+" -> profit "+profit)
			this.game_state.money += profit
		}

		if(this.bubble)
			this.bubble.removeAll()
		this.bubble = game.add.group()
		this.base.add(this.bubble)
		if(step.party == "customer")
			this.bubble.create(0, 0, "customer_bubble_narrow")
		else if(step.party == "mechanic")
			this.bubble.create(0, 0, "mechanic_bubble_narrow")
		var style = {
			fontSize: FONT_SIZE,
			fill: "#ffffff",
			stroke: "#1e1e1e",
			strokeThickness: 1,
			wordWrap: true,
			wordWrapWidth: 770,
		}
		var text = step.header+"\n"+step.text
		this.bubble.text = game.add.text(150, 40, text, style)
		this.bubble.add(this.bubble.text)
		//this.bubble.button = game.add.button(820, 100, "continue_button", function(){
		this.bubble.button = game.add.button(1000-34, 600-32, "continue_button", function(){
			this.on_press_next()
		}, this, 2, 1, 0)
		this.bubble.button.events.onInputOver.add(function(){
			this.bubble.button.tint = 0x88ff88
		}, this)
		this.bubble.button.events.onInputOut.add(function(){
			this.bubble.button.tint = 0xffffff
		}, this)
		this.bubble.add(this.bubble.button)
	},
	on_key_down: function(key){
		if(key.keyCode == Phaser.Keyboard.SPACEBAR || key.keyCode == Phaser.Keyboard.ENTER)
			this.on_press_next()
	},
	on_press_next: function(){
		console.log("on_press_next")
		this.sequence_i++
		if(this.sequence_i < this.sequence.length){
			this.update_bubble()
			return
		}
		this.remove()

		// Remove the procedure section
		sections.remove(sections.top())
		// Remove the finished engine bay section
		sections.remove(sections.top())

		if(this.game_state.money < 0){
			sections.push(new GameOverSection(this.game_state))
		} else {
			// Get new customer
			get_new_customer(this.game_state)
			sections.push(new EngineBaySection(this.game_state))
			sections.push(new PreDiscussWithCustomerSection(this.game_state))
		}
	},
}
