var PreDiscussWithCustomerSection = function(game_state){
	this.grabs_input = true
	this.game_state = game_state
}
PreDiscussWithCustomerSection.prototype = {
	on_init: function(){
		this.base = game.add.group()

		this.background_mouse_catch = game.add.sprite(0,  0, "empty")
		this.base.add(this.background_mouse_catch)
		this.background_mouse_catch.inputEnabled = true
		this.background_mouse_catch.input.useHandCursor = true
		this.background_mouse_catch.events.onInputUp.add(function(){
			this.on_press_next()
		}, this)

		this.background_opaque = game.add.sprite(0,  0, "empty_opaque")
		this.base.add(this.background_opaque)

		var lib = part_library[this.game_state.customer.broken_partname]
		this.sequence = []
		this.sequence = this.sequence.concat([
			{
				party: "doorbell",
				header: "Door bell",
				text: "*ring* *ring* *ringringring*",
			},
		])
		if(this.game_state.cars_fixed <= 10){
			var texts = [
				"Meh...",
				"Go away.",
				"Whaddaya want?",
				"Do you realize my rate is 50 € per hour?",
				"I ran out of notebooks for my procedures.",
				"Life means nothing to me.",
				"I need sleep.",
				"I need beer.",
				"I want out.",
				"What's wrong with these people!",
			]
			var text = texts[Math.floor(Math.random()*texts.length)]
			if(this.game_state.cars_fixed == 0)
				text = "Generic Auto Shop at your service."
			else if(this.game_state.cars_fixed <= 3)
				text = "Meh..."
			this.sequence = this.sequence.concat([
				{
					party: "mechanic",
					header: "Mechanic:",
					text: text,
					transparent_background: true,
				},
			])
		}
		this.sequence = this.sequence.concat([
			{
				party: "customer",
				header: "Customer:",
				text: "I think there's a problem with the "+lib.what+".",
				transparent_background: true,
			},
		])
		if(this.game_state.cars_fixed < 3){
			this.sequence = this.sequence.concat([
				{
					party: "mechanic",
					header: "Mechanic:",
					text: "Your car doesn't have any "+lib.what+".",
				},
				{
					party: "customer",
					header: "Customer:",
					text: "Can you fix it?",
				},
			])
		}
		if(this.game_state.cars_fixed <= 5){
			if(this.game_state.known_procedures[this.game_state.customer.broken_partname]){
				var texts = [
					"I have a procedure for this!",
					"If I don't remember the procedure, I'll just replace some vacuum hoses...",
				]
				var text = texts[Math.floor(Math.random()*texts.length)]
				if(this.game_state.cars_fixed == 0)
					text = texts[0]
				this.sequence.push({
					party: "mechanic",
					header: "Mechanic:",
					text: "Ok, fine, I'll fix it. "+text,
					transparent_background: true,
				})
			} else {
				this.sequence.push({
					party: "mechanic",
					header: "Mechanic:",
					text: "Ok, fine, I'll fix it.",
					transparent_background: true,
				})
			}
		}
		this.sequence_i = 0

		this.update_bubble()

		add_statusbar(this.base, this.game_state)
	},
	on_remove: function(){
		this.base.destroy()
	},
	update_bubble: function(){
		var step = this.sequence[this.sequence_i]
		if(step.transparent_background)
			this.background_opaque.destroy()
		if(this.bubble)
			this.bubble.removeAll()
		this.bubble = game.add.group()
		this.base.add(this.bubble)
		if(step.party == "customer")
			this.bubble.create(0, 0, "customer_bubble_narrow")
		else if(step.party == "mechanic")
			this.bubble.create(0, 0, "mechanic_bubble_narrow")
		var style = {
			fontSize: FONT_SIZE,
			fill: "#ffffff",
			stroke: "#1e1e1e",
			strokeThickness: 1,
			wordWrap: true,
			wordWrapWidth: 770,
		}
		var text = step.header+"\n"+step.text
		this.bubble.text = game.add.text(150, 40, text, style)
		this.bubble.add(this.bubble.text)
		//this.bubble.button = game.add.button(820, 100, "continue_button", function(){
		this.bubble.button = game.add.button(1000-34, 600-32, "continue_button", function(){
			this.on_press_next()
		}, this, 2, 1, 0)
		this.bubble.button.events.onInputOver.add(function(){
			this.bubble.button.tint = 0x88ff88
		}, this)
		this.bubble.button.events.onInputOut.add(function(){
			this.bubble.button.tint = 0xffffff
		}, this)
		this.bubble.add(this.bubble.button)
	},
	on_key_down: function(key){
		if(key.keyCode == Phaser.Keyboard.SPACEBAR || key.keyCode == Phaser.Keyboard.ENTER)
			this.on_press_next()
	},
	on_press_next: function(){
		console.log("on_press_next")
		this.sequence_i++
		if(this.sequence_i < this.sequence.length){
			this.update_bubble()
			return
		}
		this.remove()

		/*if(this.game_state.known_procedures[this.game_state.customer.broken_partname]){
			sections.push(new RecallProcedureSection(this.game_state,
					this.game_state.known_procedures[this.game_state.customer.broken_partname], function(){
				sections.remove(sections.top())
			}))
		}*/
	},
}
