(function(){var M={}
SECTION = M

SECTION.Stack = function(game){
	this.game = game
	this.sections = []
}

SECTION.Stack.prototype = {
	top: function(){
		if(this.sections.length == 0)
			return undefined
		return this.sections[this.sections.length-1]
	},
	push: function(section){
		if(section.opaque){
			for(var i=0; i<this.sections.length; i++)
				if(this.sections[i].on_hide)
					this.sections[i].on_hide()
		}
		if(section.grabs_input){
			for(var i=0; i<this.sections.length; i++){
				if(this.sections[i].on_disable_input)
					this.sections[i].on_disable_input()
			}
		}
		this.sections.push(section)
		section.on_init()

		// Add the remove() function to the section
		var section_stack = this
		section.remove = function(){
			section_stack.remove(section)
		}
	},
	remove: function(section){
		if(!section)
			return
		var was_hiding = (section == this.top() && section.opaque)
		var was_grabbing_input = (section == this.top() && section.grabs_input)
		if(section.on_remove)
			section.on_remove()
		this.sections = this.sections.filter(function(section0){
			if(section0 == section)
				return false
			return true
		})
		if(was_hiding && this.top() && this.top().on_show)
			this.top().on_show()
		if(was_grabbing_input && this.top() && this.top().on_enable_input)
			this.top().on_enable_input()
	},
	on_key_down: function(key){
		// TODO: Propagate as needed
		if(this.top() && this.top().on_key_down)
			this.top().on_key_down(key)
	},
	on_key_up: function(key){
		// TODO: Propagate as needed
		if(this.top() && this.top().on_key_up)
			this.top().on_key_down(key)
	},
	on_key_press: function(key){
		// TODO: Propagate as needed
		if(this.top() && this.top().on_key_press)
			this.top().on_key_press(key)
	},
}

})()
